{
  lib,
  alsa-lib,
  gtk3,
  fetchFromGitHub,
  rustPlatform,
  openssl,
  pkg-config,
  jack2,
  python3,
  cmake,
  libopus,
  steam-run,
}:

rustPlatform.buildRustPackage rec {
  pname = "noita-entangled-worlds-proxy";
  version = "v1.5.1";

  src = fetchFromGitHub {
    owner = "IntQuant";
    repo = "noita_entangled_worlds";
    rev = version;
    hash = "sha256-v5aulgWkPhgkPHfHb1j/39JauKfFhFCHRfBgm2UJHYc=";
  };

  sourceRoot = "${src.name}/noita-proxy";

  useFetchCargoVendor = true;
  cargoHash = "sha256-1YkLTp3QUaC1oU1SwmuOJMTklptfZu2gIonDyLfLhCk=";
  buildInputs = [
    gtk3
    openssl
    jack2
    alsa-lib
    libopus
  ];
  nativeBuildInputs = [
    pkg-config
    python3
    cmake
    steam-run
  ];
  preInstall = ''
    mkdir -p $out/share/lib64/noita-proxy
    cp ${src}/redist/libsteam_api.so $out/share/lib64/noita-proxy
  '';
  postInstall = ''
    mv $out/bin/noita-proxy $out/bin/noita-proxy-unwrapped
    cat > $out/bin/noita-proxy <<EOF
      #!/usr/bin/env bash

      export LD_PRELOAD=$out/share/lib64/noita-proxy/libsteam_api.so
      exec ${steam-run}/bin/steam-run $out/bin/noita-proxy-unwrapped
    EOF
    chmod +x $out/bin/noita-proxy
  '';
  checkFlags = [
    # reason for disabling test
    "--skip=bookkeeping::releases::test::release_assets"
  ];
}
